/*
 * Wiki - A wiki with editor
 * Copyright (c) 2021-2021 Peter Stuifzand
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package main

import (
	"bytes"
	"html/template"
)

type editorJsJson struct {
	Page        string
	ContentType string
	BaseURL     string
	Data        template.JS
}

func renderEditor(pageName, inputText, contentType string, baseurl string) (template.HTML, error) {
	if contentType == "json" {
		t, err := template.ParseFiles("templates/editorjs.html")
		if err != nil {
			return "", err
		}
		if inputText == "" {
			inputText = "null"
		}
		data := editorJsJson{Page: pageName, Data: template.JS(inputText), ContentType: contentType, BaseURL: baseurl}
		var buf bytes.Buffer
		err = t.Execute(&buf, data)
		if err != nil {
			return "", err
		}
		return template.HTML(buf.String()), nil
	}
	return "", nil
}
